import java.rmi.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/** Diese Klasse dient zur Kommunikation mit dem
  * Messageserver ueber RMI.
  * @author Bernhard Fiser 0109815
  * @version 0.2 2002/10/22 */
public class XMessageClient extends JFrame
{
	private static String	user;

	/** Constructor initialisiert RMI Kommunikation,
	  * und initialisiert und ffnet das Fensert. */
	public XMessageClient()
	{
		/* Leeres Fenster initialisieren. */
		super("MessageClient 0.1 2002/10/23, Bernhard Fiser 0109815 - USER: " + user);
		this.addWindowListener(new WndClose());

		/* RMI Kommunikation initialisieren. */
		MessageInterface obj = MessageCommunication.init();

		/* Sende und Empfangselemente zum Fenster
		 * hinzufgen. */
		this.getContentPane().add(new XSendMessage(obj, user), BorderLayout.NORTH);
		this.getContentPane().add(new XGetMessage(obj, user), BorderLayout.SOUTH);

		/* Fensterinhalt berechnen. */
		this.pack();
	}


	/** Internet Klasse zum Schlieen des Fensters. */
	class WndClose extends WindowAdapter
	{
		public void windowClosing(WindowEvent e)
		{
			System.exit(0);
		}
	}

	/** main Methode. */
	public static void main(String argv[])
	{
		/* Prfen ob gengend Parameter bergeben. */
		if (argv.length == 0)
		{
			System.err.println("usage: java XMessageClient <user>");
			System.exit(1);
		}
		/* Username bernehmen. */
		user = argv[0];
		/* Fenster erstellen. */
		XMessageClient wnd = new XMessageClient();
		/* Fenster anzeigen. */
		wnd.setVisible(true);
	}
}

