import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/** Diese Klasse erweitert die Swingklasse JPanel
  * und enthlt alle Elemente zum Senden von
  * Nachrichten.
  * @author Bernhard Fiser 0109815
  * @version 0.2 2002/10/28 */
public class XSendMessage extends JPanel implements ActionListener
{
	private String		user;
	private JButton		b;
	private JTextField	to;
	private JTextArea	msg;
	private MessageInterface	obj;

	/** Der Constructor erzeugt alle Swingelemente. */
	public XSendMessage(MessageInterface obj, String user)
	{
		/* MessageInterface Variable speichern. */
		this.obj = obj;
		/* Username speichern. */
		this.user = user;

		/* Layout und Rahmen festlegen. */
		this.setLayout(new FlowLayout());
		this.setBorder(new TitledBorder("Nachrichten senden"));

		/* Button zum Senden initialisieren und hinzufgen. */
		this.b = new JButton("Senden");
		this.b.addActionListener(this);
		this.add(this.b);

		/* Textfeld fr Empfngeradressen initialisieren und
		 * hinzufgen. */
		this.to = new JTextField();
		this.to.setColumns(20);
		this.add(this.to);

		/* Textfeld fr Nachricht initialisieren und hinzufgen. */
		this.msg = new JTextArea(4,20);
		this.msg.setLineWrap(true);
		this.add(new JScrollPane(this.msg));
	}

	/** Diese Methode wird aufgerufen, wenn der Button
	  * gedrckt wurde. */
	public void actionPerformed(ActionEvent event)
	{
		String	toA[];
		int	i = 0;

		/* Text aus Empfngerfeld auslesen. */
		String s = this.to.getText().trim();
		/* Stringtokenizer initialisieren zum parsen
		 * des Strings. */
		StringTokenizer t = new StringTokenizer(s, ",; ");

		/* Prfen ob empfnger angegeben wurden.
		 * Sonst zurckkehren. */
		if (t.countTokens() <= 0)
			return;

		/* String Array mit Empfngern initialisieren. */
		toA = new String[t.countTokens()];
		/* Empfnger der Reihe nach ins Array schreiben. */
		while (t.hasMoreTokens())
			toA[i++] = t.nextToken();
		
		/* Nachricht verschicken. */
		try
		{
			this.obj.sendMsg(this.user, toA, this.msg.getText());
		}
		
		/* Bei fehlerhaftem Versand, Fehlermeldung ausgeben
		 * und zurckkehren. */
		catch (Exception e)
		{
			System.err.println("*** ERROR: Konnte Nachricht nicht senden.");
			return;
		}
		
		/* Nachrichtenfeld lschen. */
		this.msg.setText("");
		System.out.println("*** INFO: Nachricht gesendet.");
	}
}
